VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSComm32.ocx"
Begin VB.Form Ultraspec_1000E 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   Caption         =   "Ultraspec 1000E reader"
   ClientHeight    =   6885
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   6255
   LinkTopic       =   "Form1"
   ScaleHeight     =   459
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   417
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdReturn 
      Caption         =   "Return"
      Height          =   495
      Left            =   120
      TabIndex        =   14
      Top             =   5280
      Width           =   1335
   End
   Begin VB.Timer Timer2 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   5640
      Top             =   120
   End
   Begin VB.FileListBox FileIn 
      Height          =   3015
      Left            =   120
      Pattern         =   "x_*.txt"
      TabIndex        =   11
      Top             =   2160
      Width           =   2895
   End
   Begin VB.CheckBox chkCOM1 
      Caption         =   "ON"
      Height          =   255
      Left            =   3600
      TabIndex        =   9
      Top             =   480
      Width           =   615
   End
   Begin VB.ComboBox cmbCOM 
      Height          =   315
      Left            =   2880
      TabIndex        =   7
      Text            =   "COM1"
      Top             =   120
      Width           =   1095
   End
   Begin VB.DirListBox Dir1 
      Height          =   990
      Left            =   3120
      TabIndex        =   6
      Top             =   720
      Width           =   3015
   End
   Begin VB.FileListBox FileA 
      Height          =   3015
      Left            =   3120
      MultiSelect     =   1  'Simple
      Pattern         =   "z_*.csv"
      TabIndex        =   5
      Top             =   2160
      Width           =   3015
   End
   Begin VB.Timer Timer1 
      Left            =   5160
      Top             =   120
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   4560
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Label lblSpectrumOut 
      Caption         =   "lblSpectrumOut"
      Height          =   255
      Left            =   3120
      TabIndex        =   13
      Top             =   1800
      Width           =   2895
   End
   Begin VB.Label lblSpectrumIn 
      Caption         =   "lblSpectrumIn"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   1800
      Width           =   2895
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "lblStatus"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   15.75
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   10
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label lblComm1 
      Caption         =   "lblComm1"
      Height          =   255
      Left            =   2880
      TabIndex        =   8
      Top             =   480
      Width           =   855
   End
   Begin VB.Label lblAbs 
      Caption         =   "lblAbs"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   24
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   1200
      Width           =   1695
   End
   Begin VB.Label lblLam 
      Caption         =   "lblLam"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   24
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   1695
   End
   Begin VB.Label lblTime 
      Caption         =   "lblTime"
      Height          =   255
      Left            =   1800
      TabIndex        =   2
      Top             =   360
      Width           =   855
   End
   Begin VB.Label lblLineN 
      Caption         =   "lblLineN"
      Height          =   255
      Left            =   1800
      TabIndex        =   1
      Top             =   120
      Width           =   855
   End
   Begin VB.Label lblDT 
      Caption         =   "lblDT"
      Height          =   255
      Left            =   1800
      TabIndex        =   0
      Top             =   600
      Width           =   495
   End
End
Attribute VB_Name = "Ultraspec_1000E"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit


' UART/RS232 analyzer:
' 19200, Inverted, 8 bits, 1 stop, No parity, LSB first

' Pin 1 = Data, 19 = GND (18-22 = GND)
' Connect Pin 9 (DATA) <-> Pin 10 (ACK)

' Hardware inverted PIN 1 (NPN transistor)

'====== Serial Output ==========
'Mode        Time intervals
'Interval          5  Sec
'Wavelength        360   nm
'
'000   0        sec   Abs.= 0.000
'001   5        sec   Abs.= 0.001
'002  10        sec   Abs.= 0.001

'Mode Wavescan
'Wavelength        360   nm
'->Wavelength         900   nm
'
'360   nm Abs.= 0.000
'361   nm Abs.= 0.000
'362   nm Abs.= 0.000
'====== Serial Output ==========

' SaveSetting (registry)
' Computer\HKEY_CURRENT_USER\SOFTWARE\VB and VBA Program Settings

' Transmittance to Absorbance Table
' Absorbance = 0...3   Transmitatnce = 100% ... 0.1%
' https://www.epolin.com/absorbance/
' YT = 10 ^ (2 - YA) ' Transmittance

Dim Buf As String
Dim T0 As Double
Dim Fname As String

Dim COMport1 As Integer

Dim T00 As Single      '
Dim FileOpen As Boolean      ' TmpFile status
Dim TmpFileTime As String    ' start time of spectrum mesurament
Dim TmpFileName As String    ' 'time'.txt
Dim TmpFileData() As String  ' Spectrum data array: Lambda;Absorbance
Dim LineN As Integer         ' Lines read

Private Sub cmbCOM_Click()
   Comm1Set
End Sub

Private Sub chkCOM1_Click()
   If chkCOM1.Value = 1 Then Comm1Open Else Comm1Close
End Sub


Private Sub cmdReturn_Click()
  Dim DateTime
  Dim DT As String, L12 As String
  
  If FileA.FileName = "" Then Exit Sub
  L12 = Lambda(FileA.FileName)
  
  DateTime = FileDateTime(FileA.FileName)
  DT = Mid(DateTime, 14, 10)
  DT = Replace(DT, ":", "")
  
  Name FileA.FileName As "x_" + L12 + "_" + DT + ".txt"
  FileIn.Refresh
  FileA.Refresh
End Sub

Private Sub FileA_Click()
      If FileA.FileName = "" Then Exit Sub
      lblSpectrumOut.Caption = FileA.FileName
End Sub

Private Sub FileIn_Click()
Dim n1 As Integer
Dim ch As String

' rename scanned file, from date/time to meaningful name
Dim xFile As String, yFile As String, L12 As String

      xFile = App.Path + "\" + FileIn.FileName
      L12 = Lambda(xFile) ' read MIn, MAX Lambda
      yFile = FileA.FileName
      yFile = Mid(yFile, InStrRev(yFile, "_") + 1)
      yFile = Mid(yFile, 1, Len(yFile) - 4)
      
      Fname = InputBox("File prefix: z_" + L12, "Input Sample Name", yFile)
      If Fname = "" Then Exit Sub
      
      If InStr(Fname, ".csv") = 0 Then Fname = "z_" + L12 + "_" + Fname + ".csv"
      Fname = App.Path + "\" + Fname
      
      If Dir(Fname) <> "" Then Fname = Replace(Fname, ".csv", "-A.csv")
      
      On Error GoTo Napaka
      Name xFile As Fname
       
      
      FileA.Refresh
      FileIn.Refresh
Exit Sub

Napaka:
      
      n1 = InStr(Fname, "-.")
      If n1 <> 0 Then
         ch = Asc(Mid(Fname, n1 - 1))
         Fname = Replace(Fname, "-" + Chr(ch) + "-", "-" + Chr(ch + 1) + "-")
      Else
         Fname = Replace(Fname, ".csv", "-A-.csv")
      End If
      
      Resume
      
End Sub

Private Function Lambda(xFile) As String
' return Lambda range from file
Dim L1 As String
Dim L2 As String
Dim a$
      Open xFile For Input As #5
      Line Input #5, a$
      L1 = Mid(a$, 1, 3)
      While Not EOF(5)
      Line Input #5, a$
      
      Wend
      L2 = Mid(a$, 1, 3)
      Close #5
Lambda = L1 + "-" + L2
End Function

Private Sub Form_Load()
   CommPortsList ' list COM ports
   CommPortsSet  ' read last COM port from registry
   chkCOM1.Value = 1
   
   ' FileA.MultiSelect = 1 ' Select, Unselect // set in IDE only
   
   Timer1.Interval = 200
   Timer1.Enabled = True
   
   lblStatus.BackColor = vbRed
   lblStatus.Caption = "Waiting"
   
End Sub

Private Sub Timer1_Timer()
Dim i As Integer
Dim L1 As String, L2 As String
  If Timer - T00 > 2 Then
     If FileOpen Then
        L1 = Mid(TmpFileData(0), 1, 3)  ' read MIn, MAX Lambda
        L2 = Mid(TmpFileData(UBound(TmpFileData)), 1, 3)
        TmpFileName = "x_" + L1 + "-" + L2 + "_" + TmpFileTime + ".txt"
        
        Open App.Path + "\" + TmpFileName For Output As #1
        For i = 200 To UBound(TmpFileData) ' <<<<<<<<<<<<<<<<<<
           Print #1, TmpFileData(i)
        Next i
        Close #1
        FileOpen = False
     
        FileIn.Refresh
        lblStatus.BackColor = vbRed
        lblStatus.Caption = "Waiting"
    End If
   End If
End Sub

' ===== COMM (Serial) routines =============

Private Sub Comm1Set()
chkCOM1.Value = 0: DoEvents
On Error GoTo Napaka
    COMport1 = Val(Replace(cmbCOM.Text, "COM", ""))
    If COMport1 > 1 Then
       SaveSetting "Biotech", "Serial", "COM", Format(COMport1)
       lblComm1.Caption = "COM:" + Format(COMport1)
       MSComm1.CommPort = COMport1
       MSComm1.Settings = "19200,n,8,1"
       MSComm1.RThreshold = 1
    End If
Exit Sub
Napaka:
   lblComm1.Caption = "Err"
   cmbCOM.BackColor = vbYellow
End Sub

Private Sub Comm1Open()
On Error GoTo Napaka
   If MSComm1.PortOpen = False Then MSComm1.PortOpen = True
   Timer1.Enabled = True
   cmbCOM.BackColor = vbGreen
Exit Sub

Napaka:
cmbCOM.BackColor = vbYellow
End Sub

Private Sub Comm1Close()
On Error GoTo Napaka
   If MSComm1.PortOpen = True Then MSComm1.PortOpen = False
   Timer1.Enabled = False
   cmbCOM.BackColor = vbRed
Exit Sub
Napaka:
cmbCOM.BackColor = vbYellow
End Sub


Private Sub MSComm1_OnComm()
Dim n1 As Integer, i As Integer
Dim Out As String
Dim v As Variant
On Error GoTo Konec
  If MSComm1.CommEvent = comEvReceive Then
    Buf = Buf + MSComm1.Input
    n1 = InStr(Buf, vbCrLf)
    If n1 > 0 Then
       Out = Mid(Buf, 1, n1 - 1)
       Buf = Mid(Buf, n1 + 2)
       v = Split(Out, vbTab)
       lblLam.Caption = v(0)
       lblAbs.Caption = v(3)
       If UBound(v) = 3 Then
        If FileOpen = False Then
           TmpFileTime = Replace(Format(Time), ":", "")
           
           lblSpectrumIn.Caption = TmpFileTime
           FileOpen = True
           ReDim TmpFileData(0)
           T0 = Timer
           lblStatus.BackColor = vbGreen
           lblStatus.Caption = "Running"
        End If
        
        'Print #1, v(0) + ";" + v(3)
        'TmpFileData = TmpFileData + v(0) + ";" + v(3) + vbCrLf
        
        ReDim Preserve TmpFileData(LineN)
        TmpFileData(LineN) = v(0) + ";" + v(3)
        LineN = LineN + 1
        
        lblLineN.Caption = LineN
        lblTime.Caption = Format(Timer - T0, "#.0")
        lblDT.Caption = Format(Timer - T00, "#.00")

        T00 = Timer
        
       End If
       
    End If
  End If
Konec:
End Sub

' -------------- FindComPorts --------------

Private Sub CommPortsSet()
    COMport1 = Val(GetSetting("Biotech", "Serial", "COM", "9"))
    Dim i As Integer, COM As String
    For i = 0 To cmbCOM.ListCount - 1
        COM = cmbCOM.List(i)
        If Val(Replace(COM, "COM", "")) = COMport1 Then cmbCOM.ListIndex = i
    Next
End Sub

Private Sub CommPortsList()
   cmbCOM.Clear
   Dim port As Long
   For port = 1 To 50
      If COMCheckPort(port) Then
         cmbCOM.AddItem "COM" & port
      End If
   Next
Konec:
End Sub

Private Function COMCheckPort(port As Long) As Boolean

  'Returns false if port cannot be opened or does not exist
  'Returns true if port is available and can be opened
   
  'Handle all errors
   On Error GoTo OpenCom_Error
   
  'Set port number for test
   MSComm1.CommPort = port
   
   If MSComm1.PortOpen = True Then
      COMCheckPort = False
      Exit Function
   Else
     'Test the port by opening and closing it
      MSComm1.PortOpen = True
      MSComm1.PortOpen = False
      COMCheckPort = True
      Exit Function
   End If
   
OpenCom_Error:
   COMCheckPort = False
   
End Function



